CSP模拟52联测14 C.天竺葵

CSP模拟52联测14 C.天竺葵

文章目录

题目大意

给定两个长度为 n n n 的序列 a , b a , b a,b

需要在 a a a 序列中好到最长的序列 c c c 满足 c i + 1 > b i × c i c _{i + 1} > b_i \times c_i ci+1>bi×ci

输出长度

1 ≤ n ≤ 1 0 6 1\le n\le 10^6 1≤n≤106

思路

感觉和 n ( log ⁡ n ) n(\log n) n(logn) 求最长上升子序列差不多

考虑 d p dp dp

设 d p i dp_i dpi 为第 c i c_i ci 的最小值

朴素的转移是 O ( n 2 ) O(n^2) O(n2) 的

70分代码

cpp 复制代码
#include <bits/stdc++.h>
#define fu(x , y , z) for(int x = y ; x <= z ; x ++)

#define LL long long

using namespace std;
const int N = 1e6 + 5;
const LL inf = 1e12 + 5;
int n , ans , ans1 , lis[N] , len;
LL f[N] , a[N] , b[N] , min1;
int fans (int l , int r , LL x) {
    if (l == r) {
        return a[lis[l]] > x ? l : inf;
    }
    else {
        int mid = l + r >> 1;
        if (a[lis[mid]] >= x) return min (mid , fans (l , mid , x));
        else return fans (mid + 1 , r , x);
    }
}
int main () {
    freopen ("C.in" , "r" , stdin);
    freopen ("C.out" , "w" , stdout);
    int flg = 0 , x;
    scanf ("%d" , &n);
    fu (i , 1 , n) scanf ("%lld" , &a[i]);
    fu (i , 1 , n) {
        scanf ("%lld" , &b[i]);
        if (b[i] != 1) flg = 1;
    }
    if (!flg) {
        lis[len = 1] = 1;
        fu (i , 2 , n) {
            if (a[lis[len]] < a[i]) {
                lis[++len] = i;
                continue;
            }
            x = fans (1 , len , a[i]);
            lis[x] = i; 
        }
        printf ("%d" , len);
        return 0;
    }
    ans = 1 , f[1] = a[1];
    min1 = a[1];
    fu (i , 2 , n) f[i] = 1e12 + 5;
    fu (i , 2 , n) {
        ans1 = 0;
        fu (j , 1 , ans + 1) {
            if (a[i] > f[j - 1] * b[j - 1]) {
                f[j] = min (f[j] , a[i]);
                ans1 = max(ans1 , j);
            }
        }
        min1 = min (min1 , a[i]);
        ans = max (ans , ans1);
    }
    printf ("%d" , ans);
    return 0;
}

我们发现是转移的时候太慢了。

假设当前要处理的是 a i a_i ai

我们把现在的 d p dp dp 分成两部分前 k k k 个是小于 a i a_i ai 的,后 k k k 个是大于 a i a_i ai 的

因为 d p 1 → k ≤ a i dp_{1\to k} \le a_i dp1→k≤ai ,所以 min_{j = 1 }\^k (dp_j ,a_i)= dp_i

因为 d p k + 1 → l e n > a i dp_{k + 1 \to len} > a_i dpk+1→len>ai ,所以 a i < d p j ∗ b j ( j ∈ k + 1 , l e n ) a_i < dp_j *b_j (j\ink + 1 , len) ai<dpj∗bj(j∈k+1,len)

所以现在要更新的就只有 d p k dp_k dpk

直接遍历一遍,二分查找 k k k 就好了

时间复杂度 O ( n log ⁡ n ) O(n\log n) O(nlogn)

code

cpp 复制代码
#include <bits/stdc++.h>
#define fu(x , y , z) for(int x = y ; x <= z ; x ++)
#define LL long long
using namespace std;
const int N = 1e7 + 5;
const LL inf = 1e12 + 5;
int n , ans , ans1 , lis[N] , len;
__int128 f[N] , a[N] , b[N] , min1;
int fans (int l , int r , LL x) {
    if (l == r) {
        return a[lis[l]] > x ? l : inf;
    }
    else {
        int mid = l + r >> 1;
        if (a[lis[mid]] >= x) return min (mid , fans (l , mid , x));
        else return fans (mid + 1 , r , x);
    }
}
int main () {
    freopen ("C.in" , "r" , stdin);
    freopen ("C.out" , "w" , stdout);
    LL x;
    scanf ("%d" , &n);
    fu (i , 1 , n) scanf ("%lld" , &x) , a[i] = x;
    fu (i , 1 , n) scanf ("%lld" , &x) , b[i] = x;
    int k;
    ans = 1 , f[1] = a[1];
    min1 = a[1];
    fu (i , 2 , n) {
        k = lower_bound(f + 1 , f + ans + 1 , a[i]) - f - 1;
        if (k == ans) {
            if (a[i] > b[ans] * f[ans]) f[++ans] = a[i];
        }
        else {
            if (a[i] > b[k] * f[k]) f[k + 1] = a[i];
        }
    }
    printf ("%d" , ans);
    return 0;
}
相关推荐
richard_yuu7 小时前
动态规划:强化学习的「数学基础」,从 MDP 到值迭代
深度学习·神经网络·算法·yolo·机器学习·动态规划
lvwangshu1 天前
P12960 毒药 题解
动态规划·题解·贪心·技巧·性质题·思维好题
彧azz8 天前
算法设计与分析:贪心与动态规划
数据结构·学习·算法·贪心算法·动态规划
Logic10110 天前
C语言/数据结构动态规划题解:Kadane算法求最大子数组和——O(n)时间O(1)空间
c语言·数据结构·动态规划·贪心·时间复杂度·算法题·最大子数组和
梦帮科技10 天前
AI 音乐产品的发布工程:验证门、数据发布、回滚与生产运维纪律
数据结构·数据库·架构·node.js·音视频·动态规划·推荐算法
语戚10 天前
力扣 1621. 大小为K的不重叠线段的数目:动态规划(Java 实现)
java·算法·leetcode·动态规划·力扣·dp
青山木10 天前
Hot 100 --- 最长有效括号
java·数据结构·算法·leetcode·动态规划
这料鬼有毒10 天前
二刷hot100-1143.最长公共子序列
算法·leetcode·动态规划
Tisfy11 天前
LeetCode 1477.找两个和为目标值且不重叠的子数组:滑动窗口 + 记录前值(动态规划)
动态规划·题解·dp·滑动窗口
ynchyong12 天前
动态规划解题思路:入门篇
动态规划